<?php
/*
Plugin Name: Pti's Text-Math Antispam for comment
Plugin URI: http://www.ptipti.ru/pti_math/
Description: A simple plugin displays a math question in the form of text while writing a comment
Author: Pti_the_Leader
Version: 1.3
Author URI: http://www.ptipti.ru/
*/

session_start();
//Подключаем файл локализации, если такавой имеется;
load_plugin_textdomain ('ptimathcapcha', PLUGINDIR.'/'.dirname (plugin_basename(__FILE__)), dirname (plugin_basename(__FILE__)));

//Подключаем плугин к ядру Wordpress;
add_action ('comment_form', 'draw_form');
add_action ('comment_post', 'check_capcha');

//Настройки плагина;
register_activation_hook (__FILE__, 'set_pti_options');
register_deactivation_hook (__FILE__, 'unset_pti_options');
add_action ('admin_menu', 'modify_pti_plugin');
add_filter ('plugin_action_links', 'set_pti_plugin_meta', 10, 2);

//фанкшаны;
function draw_form ($id) {
	global $user_ID;
	//Показываем капчу только неавторизованным. Зареганые пользователи уже отмучались;
	if( $user_ID ) {
		return $id;
	} else {
		$a = rand (1, 9);
		$b = rand (1, 9);
		$mathaction = rand (0, 11);
		$question = __('Q:', 'ptimathcapcha').' ';
		if ( $mathaction <= 4 ) { //Сумма;
			$result = $a+$b;
			$a = convert_to_text ($a);
			$b = convert_to_text ($b);
			$question .= $a.' '.__('plus', 'ptimathcapcha').' '.$b;
		} elseif ( $mathaction <= 8 ) { //Вычитание;
			if ( $a > $b ) {
				$result = $a-$b;
				$a = convert_to_text ($a);
				$b = convert_to_text ($b);
				$question .= $a.' '.__('minus', 'ptimathcapcha').' '.$b;
			} else {
				$result = $b-$a;
				$a = convert_to_text ($a);
				$b = convert_to_text ($b);
				$question .= $b.' '.__('minus', 'ptimathcapcha').' '.$a;
			}
		} else { //Умножение;
			$result = $a*$b;
			$a = convert_to_text ($a);
			$b = convert_to_text ($b);
			$question .= $a.' '.__('multiplied by', 'ptimathcapcha').' '.$b;
		}
		$question .=' '. __('is...', 'ptimathcapcha');
		$_SESSION['qdata'] = $question;
		?>
        	<p id="pticaptcha"><input type="text" name="useranswer" maxlength="2" tabindex="3" class="tf"  size="22" /><label for="useranswer"><small><?php if (get_option ('use_img')) { echo '<img src="'.get_option('siteurl').'/'.PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/make_image.php" alt="" />'; } else { echo ' '.$question; } ?><span style="color:red; font-weight:bold"> *</span></small></label></p>
		<input type='hidden' name='question_id' value='<?php echo md5($result); ?>' />
<?php }

//Неудобство с расстановкой полей в ВП. Поле капчи появляется после поля ввода URL или Email, если удалён ввод URL;
?>
<script>
var uoeField = document.getElementById("url");
if ( !uoeField ) {
var uoeField = document.getElementById("email");
}
var captchaP = document.getElementById("pticaptcha");
var submitp = uoeField.parentNode;
submitp.appendChild(captchaP, uoeField);
</script><?php
}

function convert_to_text ($temp) {
if ( $temp == 1 ) { $value = __('one', 'ptimathcapcha'); }
if ( $temp == 2 ) { $value = __('two', 'ptimathcapcha'); }
if ( $temp == 3 ) { $value = __('three', 'ptimathcapcha'); }
if ( $temp == 4 ) { $value = __('four', 'ptimathcapcha'); }
if ( $temp == 5 ) { $value = __('five', 'ptimathcapcha'); }
if ( $temp == 6 ) { $value = __('six', 'ptimathcapcha'); }
if ( $temp == 7 ) { $value = __('seven', 'ptimathcapcha'); }
if ( $temp == 8 ) { $value = __('eight', 'ptimathcapcha'); }
if ( $temp == 9 ) { $value = __('nine', 'ptimathcapcha'); }
return $value;
}

function check_capcha ($id) {
	global $user_ID;
	if ($user_ID){
		return $id;
	} else {
		if ( md5 ($_POST['useranswer']) != $_POST['question_id'] ){
			wp_set_comment_status ($id, 'spam'); ?>
			<div align="center" style="background-color:#FFBFC1; border:solid 1px #B30004; color: #B30004; padding: 3px;"><?php _e('Stop smam to this site or use a calculator.', 'ptimathcapcha'); ?></div><?php
			exit();
		}
	}
}

function set_pti_options () {
add_option ('use_img', 'TRUE', '', 'yes');
}

function unset_pti_options () {
delete_option ('use_img');
}

function modify_pti_plugin () {
add_options_page ( __('Changing Ptis Antispam Plugin Options', 'ptimathcapcha'), __('Antispam options', 'ptimathcapcha'), 'manage_options', __FILE__, 'admin_antispam_options');
}

function admin_antispam_options () {
echo '<div class="wrap"><h2>'. __('Changing Ptis Antispam Plugin Options', 'ptimathcapcha').'</h2>';
if ($_REQUEST ['submit']) { update_pti_options (); }
echo '<form method="post"><label for="use_img_post"><input type="checkbox" '; if (get_option ('use_img')) { echo 'CHECKED '; } echo 'name="use_img_post" value="use_img_post" /> '. __('Convert sentenses to image', 'ptimathcapcha').'</label><br /><br /><input type="submit" name="submit" value="'. __('Submit', 'ptimathcapcha').'" /></form>';
}

function update_pti_options () {
if ($_REQUEST ['use_img_post']) { $use_img_to = TRUE; } else { $use_img_to = FALSE;}
	if (update_option ('use_img', $use_img_to)) {
		echo '<div id="message" class="updated fade" align="center"><p><strong>'. __('Options updated.', 'ptimathcapcha').'</strong></p></div>';
	} else {
		echo '<div id="message" class="error fade" align="center"><p><strong>'. __('Failed to update options!', 'ptimathcapcha').'</strong></p></div>';
	}
}


function set_pti_plugin_meta ($links, $file) {
if ( $file != plugin_basename( __FILE__ )) { return $links; }
	$pti_settings_link = '<a href="options-general.php?page='.dirname (plugin_basename(__FILE__)).'/ptimathcapcha.php">'. __('Antispam options', 'ptimathcapcha').'</a>';
	array_push ($links, $pti_settings_link);
 	return $links;
}
?>